﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using System.Windows.Media;

namespace JasRibbonApplicatie.Converters
{
    public class TimeFromMagazijnierIdConverter : IMultiValueConverter
    {
        /* methode krijgt array van objects (Magazijnier, Date) binnen.
         * methode returns null als geen magazijnier gevonden voor die dag
         * uur als string als er een magazijnier is gevonden voor die dag
         */

        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            DateTime date;
            int magazijnier_id;

            try
            {
                date = DateTime.Parse(values[1].ToString());
                magazijnier_id = ((Classes.Magazijnier)values[0]).MagazijnierId;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
                return null;
            }

            if (date != null && magazijnier_id != 0)
            {
                List<Classes.PlanningMagazijnier> planningen = Queries.GetPlanningMagazijniersByDatum(date).Where(p => p.Magazijnier.MagazijnierId == magazijnier_id).ToList();
                if (planningen.Count > 0)
                {
                    Classes.PlanningMagazijnier planning = planningen.First();
                    return planning.Datum.Hour.ToString("00") + 'u' + planning.Datum.Minute.ToString("00");
                }
            }
            return null;
        }


        // convert back niet mogelijk!!! && niet nodig
        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

    }
}
