﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using JasRibbonApplicatie.Classes;

namespace JasRibbonApplicatie.Views.BeheerAanvragen
{
    /// <summary>
    /// Interaction logic for MateriaalAanvragen.xaml
    /// </summary>
    public partial class MateriaalAanvragen : Page
    {
        private Aanvraag aanvraag;
        private Login login = null;
        public MateriaalAanvragen()
        {
            InitializeComponent();
            login = Login.Instance;
            setAanvraag(login.MainWindowReference.SelectedAanvraag);
            login.MainWindowReference.AanvragenSelectieGroup.Visibility = Visibility.Collapsed;
            materiaalPicker.MateriaalTypes = Queries.GetAllTypeMateriaalMetToebehoren();
        }
        public void setAanvraag(Aanvraag av)
        {
            aanvraag = av;
            materiaalDataGrid.ItemsSource = aanvraag.BesteldeMateriaal;
        }
        private void materiaalToevoegen_Click(object sender, RoutedEventArgs e)
        {
            //BeheerAanvragenMateriaalToevoegenWindow bamtw = new BeheerAanvragenMateriaalToevoegenWindow(this);
            //bamtw.Show();
            //image1.Source = new ImageSourceConverter().ConvertFromString(StreepjesCode.getStreepjesCode("g001D")) as ImageSource;

        }

        private void MateriaalToevoegButton_Click(object sender, RoutedEventArgs e)
        {
            if (materiaalPicker.selectedMateriaalType != null)
            {
                TypeMateriaalMetToebehoren selectedMateriaal = materiaalPicker.selectedMateriaalType;
                List<MateriaalBestelling> besteldeMateriaal = aanvraag.BesteldeMateriaal;
                var m =(from b in besteldeMateriaal
                        where b.MateriaalType_id == selectedMateriaal.materiaalType_id
                        select b);
                if(m.Count() == 1 )
                    m.First().AantalGoedgekeurd++;
                else if(m.Count() == 0)
                    besteldeMateriaal.Add(new MateriaalBestelling(selectedMateriaal.materiaalType_id,aanvraag.AanvraagId,0,1));
                aanvraag.BesteldeMateriaal = besteldeMateriaal;
                aanvraag.SaveBesteldeMateriaal();
                materiaalDataGrid.ItemsSource = aanvraag.BesteldeMateriaal;
            }
        }


    }
}
